import { Meta, Typeset, Story, Canvas } from '@storybook/blocks';
import { width } from './util/decorator';
import { cuiDemo } from './util/demo';
import { demoTextColor, demoBackgroundColor, demoHoverColor, demoLinkColor, demoResetColor } from './util/utilities';
import * as UtilitiesColorStories from './Utilities-color.stories';

<Meta of={UtilitiesColorStories} />

# Colors

CUI supports different color palettes. To quickly and easily access theme colors in component style, use the SCSS color function provided in CUI's *mixins* called `cui-color`. After importing the mixin, simply call the `cui-color` function and provide a **palette name** as well as a **modifier**, e.g. `color: cui-color(primary, text)`

Always keep in mind that using color to add meaning only provides a visual indication, which will not be conveyed to users of assistive technologies – such as screen readers. Ensure that information denoted by the color is either obvious from the content itself (e.g. the visible text), or is included through alternative means, such as additional hidden text.

## Text color

Use `.cui-text-*` classes to adjust the text color of an element.

<Canvas withSource="open">
  <Story of={UtilitiesColorStories.TextColor} />
</Canvas>

## Background color

Use `.cui-bg-*` classes to adjust the background color of an element.

<Canvas withSource="open">
  <Story of={UtilitiesColorStories.BackgroundColor} />
</Canvas>

## Hover color

Use `.cui-text-*-hover` or `.cui-bg-*-hover` classes to adjust the text color or background color of an element *only* on hover state. These classes can obviously be combined with `.cui-text-*` and `.cui-bg-*` respectively.

<Canvas withSource="open">
  <Story of={UtilitiesColorStories.HoverColor} />
</Canvas>

## Link color

You can use the `.cui-link-*` classes to colorize links. Unlike the `.cui-text-*` classes, these classes have a *:hover* and a *:focus* state.

<Canvas withSource="open">
  <Story of={UtilitiesColorStories.LinkColor} />
</Canvas>

## Reset color

Reset a text or link’s color with `.cui-text-reset`, so that it inherits the color from its parent.

<Canvas withSource="open">
  <Story of={UtilitiesColorStories.ResetColor} />
</Canvas>
